;nyquist plug-in
;version 3
;type process
;name "Limiter..."
;action "Limiting peaks..."

;; limiter.ny by Steve Daulton (www.easyspacepro.com). March 2014
;; Released under terms of the GNU General Public License version 2:
;; http://www.gnu.org/licenses/old-licenses/gpl-2.0.html

;control level "Limit peaks to (dB)" real "" -3 -10 0
;control make-up "Make-up gain" choice "Off,On" 0

(setq level (min 1 (db-to-linear level)))

(setf make-up
  (case make-up
    (0 1)
    (T level)))


(defun limit (s-in level make-up)   
  (let* ((la-time (/ 300.0))                      ; lookahead time (seconds)
         (la-s (round (* la-time *sound-srate*))) ; lookahead samples
         (pad-time (* 3 la-time))                 ; padding required at start (s)
         (pad-s (* 3 la-s))                       ; padding smaples
         (s-in (mult s-in (/ level)))
         (padding (snd-const (peak s-in pad-s) 0 *sound-srate* (* 3.0 la-time)))
         (peak-env (snd-avg s-in (* 4 la-s) la-s OP-PEAK))
         (peak-env (sim padding (at-abs pad-time (cue peak-env))))
         (peak-env (extract 0 1 (s-max 1 peak-env))))
    (mult s-in
      (/ level make-up)
      (snd-exp 
        (mult -1 (snd-log peak-env))))))

(multichan-expand #'limit s level make-up)
